/*
** Copyright (c) Oracle Corporation 2001-2002. All Rights Reserved.
**
**34567890123456789012345678901234567890123456789012345678901234567890123456789
*/
function _noopFormat(
  value
  )
{
  return value;
}


function _cjkParse(
  parseString
  )
{
  var i = 0;
  var length = this._length;

  while (i < parseString.length)
  { 
    var ch = parseString.charCodeAt(i);
    if (ch < 0x80) length--;
    else length -= 2;
   
    if (length < 0)
    {
      _setFailedPos(i);
      return (void 0);
    }

    i++;
  }

  return parseString;
}


function CjkFormat(
  length
  )
{
  this._class = "CjkFormat";
  this._length = length;
}


CjkFormat.prototype = new Format();
CjkFormat.prototype.format = _noopFormat;
CjkFormat.prototype.parse  = _cjkParse;


function _utf8Format(
  value
  )
{
  return value;
}


function _utf8Parse(
  parseString
  )
{
  var i = 0;
  var length = this._length;

  while (i < parseString.length)
  { 
    var ch = parseString.charCodeAt(i);
    if (ch < 0x80) length--;
    else if (ch < 0x800) length -= 2;
    else
    {
      // Surrogates...
      if ((ch & 0xFC00) == 0xD800)
        length -= 4;
      else
        length -= 3;
    }

    if (length < 0)
    {
      _setFailedPos(i);
      return (void 0);
    }

    i++;
  }

  return parseString;
}


function Utf8Format(
  length
  )
{
  this._class = "Utf8Format";
  this._length = length;
}


Utf8Format.prototype = new Format();
Utf8Format.prototype.format = _noopFormat;
Utf8Format.prototype.parse  = _utf8Parse;



function _sbParse(
  parseString
  )
{
  if (this._length < parseString.length)
  {
    _setFailedPos(this._length);
    return (void 0);
  }

  return parseString;
}


function SBFormat(
  length
  )
{
  this._class = "SBFormat";
  this._length = length;
}


SBFormat.prototype = new Format();
SBFormat.prototype.format = _noopFormat;
SBFormat.prototype.parse  = _sbParse;

function _setFailedPos(i)
{
  window["_failedPos"] = i;
}